#!/usr/bin/env ruby

require 'test/unit'
require 'flexmock'

class TestTuIntegrationMockVerificationInTeardown < Test::Unit::TestCase
  include FlexMock::TestCase

  def setup
    super
  end

  def teardown
    assert_raise(Test::Unit::AssertionFailedError) do
      super
    end
  end

  def test_mock_verification_occurs_during_teardown
    flexmock("xyz").should_receive(:hi).with(any).once
  end
end

class TestTuIntegrationMockVerificationWithoutSetup < Test::Unit::TestCase
  include FlexMock::TestCase

  def teardown
    assert_raise(Test::Unit::AssertionFailedError) do
      super
    end
  end

  def test_mock_verification_occurs_during_teardown
    flexmock("xyz").should_receive(:hi).with(any).once
  end
end

class TestTuIntegrationMockVerificationForgetfulSetup < Test::Unit::TestCase
  include FlexMock::TestCase

  def setup
  end

  def teardown
    assert_raise(Test::Unit::AssertionFailedError) do
      super
    end
  end

  def test_mock_verification_occurs_during_teardown
    flexmock("xyz").should_receive(:hi).with(any).once
  end
end

class TestTuIntegrationSetupOverridenAndNoMocksOk < Test::Unit::TestCase
  include FlexMock::TestCase

  def setup
  end

  def test_mock_verification_occurs_during_teardown
  end
end
